class User < ActiveRecord::Base
  has_many :submissions
  has_many :tasks, :through => :submissions
  before_save :encrypt_passwd

  attr_accessible :email, :neptun, :encrypted_passwd, :salt, :passwd, :passwd_confirmation, :student
  attr_accessor :passwd
  
  validates :neptun, :uniqueness => true, :presence => true, :format => {:with => /\A[a-zA-Z0-9]{6}\z/, :message => "Not a Neptun code"}
  validates :passwd, :confirmation => true, :if => :password_required?
  #validates :passwd_confirmation, :presence => true
  
  def self.encrypt(pass,salt)
    Digest::SHA1.hexdigest(salt+pass)
  end
  
  def encrypt_passwd
    return if passwd.blank?
    if new_record?
      self.salt = Digest::SHA1.hexdigest(Time.now.to_s+email+"----"+neptun)
    end
    self.encrypted_passwd = User.encrypt(passwd,salt)
  end
  
  def self.authenticate(n,p)
    user = User.find_by_neptun n
    user && user.authenticated?(p) ? user : nil
  end
  
  def authenticated?(passwd)
    encrypted_passwd == User.encrypt(passwd,salt)
  end
  
  def password_required?
    encrypted_passwd.blank? || !passwd.blank?
  end
end
