require 'test_helper'

class TasksControllerTest < ActionController::TestCase
  setup do
    @task = tasks(:elso)
  end

  test "should get index" do
    get :index
    assert_response :success
    assert_not_nil assigns(:tasks)
  end

  test "should get new" do
    get :new
    assert_response :success
  end

  test "should create task" do
    assert_difference('Task.count') do
      post :create, task: { deadline: @task.deadline, number: @task.number, url: @task.url }
    end

    assert_redirected_to task_path(assigns(:task))
  end

  test "should show task" do
    get :show, id: @task
    assert_response :success
  end

  test "should get edit" do
    get :edit, id: @task
    assert_response :success
  end

  test "should update task" do
    put :update, id: @task, task: { deadline: @task.deadline, number: @task.number, url: @task.url }
    assert_redirected_to task_path(assigns(:task))
  end

  test "should destroy task" do
    assert_difference('Task.count', -1) do
      delete :destroy, id: @task
    end

    assert_redirected_to tasks_path
  end
  
  test "submit a solution" do
    post :upload, 
      { 
        id: @task.id, 
        uid: users(:student).id, 
        upload: {
          original_filename:'test_solution.txt',
          file:fixture_file_upload('files/test_solution.txt') 
        }
      }, 
      {user:users(:student).id}
    assert_redirected_to task_path(assigns(:task))
    assert File.exists?('public/data/test_solution.txt')
  end
end
