require 'test_helper'

class SubmitSolutionTest < ActionDispatch::IntegrationTest
  fixtures :all
  test "submit a new solution" do
    get url_for(controller:'say',action:'hello')
    assert_response :success
    post_via_redirect '/sessions/create',
      { neptun:users(:student).neptun, password:'titok'},
      { 'HTTP_REFERER'=>'/say/hello' }
    assert_equal session[:user], users(:student).id
    get task_url(tasks(:elso))
    assert_response :success
    upload_file=fixture_file_upload('test/fixtures/files/test_solution.txt','text/plain')
    post url_for(controller:'tasks',action:'upload'), {
      id: tasks(:elso).id,
      uid: users(:student).id,
      upload: {
         original_filename:'test_solution.txt',
         file:upload_file
      }
    }
    s = Submission.find_by_task_id_and_user_id tasks(:elso).id, users(:student).id
    assert_not_nil s.filename
    assert File.exists?('public/data/test_solution.txt')
  end
end
